/** collaboration.h is part of JamMo.
License: GPLv2, read more from COPYING
*/
#ifndef _GEMS_H_
#define _GEMS_H_

#include <gst/gst.h>
#include "ProfileManager.h"

/* PeerHood - not yet used */
//#include <peerhood/PeerHood.h>
//#include <peerhood/IteratorWrapper.h>

typedef struct {
	ProfileManager* pm;
	
	/* PeerHood - not yet used */
	//MPeerHood* ph;
	//C_Callback* ph_cb;
	
} gems_components;

gems_components* jammo_gems_init(int* argc, char** argv[]);
void jammo_gems_cleanup(gems_components* components);

void gems_list_profile_parameters(ProfileManager* pm);//Testing only

/*Communication interface - See D2.4*/
/*The user interface calls these to inform about user actions */
void gems_add_new_sample_to_track(int track_number, const gchar srcLocation[], guint64 startTime);
void gems_add_new_sample_to_track_nth_slot(int track_number, const gchar srcLocation[], guint slot);
void gems_remove_sample_from_slot(guint track_number,int slot);
void gems_start_pair_game();
int gems_create_game_server(int port);//For testing
int gems_create_game_client(char *address, int port);//For testing

/* PeerHood - not yet used */
//void gems_ph_callback_notify(short aEvent, const char* aAddress,void* aData);
//void gems_ph_callback_newconnection(const unsigned short aPort, MAbstractConnection* aConnection, int aConnectionId, void* aData);

#endif  /* _GEMS_H_ */
